"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cdc = void 0;

var _utils = require("../utils");

var _filters = require("../filters");

const cdc = rule => s => s // eslint-disable-line import/prefer-default-export
.filter(_filters.outLatched).filter(onEventType(rule)).tap(_utils.printStartPipeline).filter(onContent(rule)).map(toQueryRequest(rule)).through((0, _utils.query)(rule)).map(toGetRequest(rule)).through((0, _utils.batchGet)(rule)).map(toEvent(rule)).parallel(rule.parallel || Number(process.env.PARALLEL) || 4).through((0, _utils.encryptEvent)(rule)).through(rule.publish(rule)).tap(_utils.printEndPipeline);

exports.cdc = cdc;

const onEventType = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnEventType)(rule, uow));

const onContent = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnContent)(rule, uow));

const toQueryRequest = rule => uow => ({ ...uow,
  queryRequest: rule.toQueryRequest // eslint-disable-line no-nested-ternary
  ?
  /* istanbul ignore next */
  rule.toQueryRequest(uow, rule) : !rule.queryRelated ? undefined : (0, _utils.toPkQueryRequest)(uow, rule)
});

const toGetRequest = rule => uow => ({ ...uow,
  batchGetRequest: rule.toGetRequest ?
  /* istanbul ignore next */
  rule.toGetRequest(uow, rule) : undefined
});

const toEvent = rule => (0, _utils.faultyAsyncStream)(async uow => !rule.toEvent ? uow : { ...uow,
  event: { ...uow.event,
    ...(await (0, _utils.faultify)(rule.toEvent)(uow, rule))
  }
});