"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.update = void 0;

var _highland = _interopRequireDefault(require("highland"));

var _utils = require("../utils");

var _filters = require("../filters");

const update = rule => s => s // eslint-disable-line import/prefer-default-export
.filter(onEventType(rule)).tap(_utils.printStartPipeline).filter(onContent(rule)).map(toQuery(rule)).through((0, _utils.query)(rule)).map(toGetRequest(rule)).through((0, _utils.batchGet)(rule)).map(toUpdateRequest(rule)).parallel(rule.parallel || Number(process.env.PARALLEL) || 4).through((0, _utils.update)(rule)).tap(_utils.printEndPipeline);

exports.update = update;

const onEventType = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnEventType)(rule, uow));

const onContent = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnContent)(rule, uow));

const toQuery = rule => uow => ({ ...uow,
  queryRequest: rule.toQueryRequest ? rule.toQueryRequest(uow, rule) : undefined
});

const toGetRequest = rule => uow => ({ ...uow,
  batchGetRequest: rule.toGetRequest ? rule.toGetRequest(uow, rule) : undefined
});

const toUpdateRequest = rule => (0, _utils.faultyAsyncStream)(uow => Promise.resolve(rule.toUpdateRequest(uow, rule)).then(updateRequest => ({ ...uow,
  updateRequest
})));