"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.putMetrics = void 0;

var _highland = _interopRequireDefault(require("highland"));

var _cloudwatch = _interopRequireDefault(require("../connectors/cloudwatch"));

var _faults = require("./faults");

var _print = require("./print");

const putMetrics = ({
  // eslint-disable-line import/prefer-default-export
  debug = (0, _print.debug)('cw'),
  putField = 'putRequest',
  parallel = Number(process.env.CW_PARALLEL) || Number(process.env.PARALLEL) || 8
} = {}) => {
  const connector = new _cloudwatch.default({
    debug
  });

  const put = uow => {
    const p = connector.put(uow[putField]).then(putResponse => ({ ...uow,
      putResponse
    })).catch((0, _faults.rejectWithFault)(uow));
    return (0, _highland.default)(p); // wrap promise in a stream
  };

  return s => s.map(put).parallel(parallel);
};

exports.putMetrics = putMetrics;