"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.invokeLambda = void 0;

var _highland = _interopRequireDefault(require("highland"));

var _lambda = _interopRequireDefault(require("../connectors/lambda"));

var _faults = require("./faults");

var _print = require("./print");

const invokeLambda = ({
  // eslint-disable-line import/prefer-default-export
  debug = (0, _print.debug)('lambda'),
  invokeField = 'invokeRequest',
  parallel = Number(process.env.LAMBDA_PARALLEL) || Number(process.env.PARALLEL) || 8
} = {}) => {
  const connector = new _lambda.default({
    debug
  });

  const invoke = uow => {
    const p = connector.invoke(uow[invokeField]).then(invokeResponse => ({ ...uow,
      invokeResponse
    })).catch((0, _faults.rejectWithFault)(uow));
    return (0, _highland.default)(p); // wrap promise in a stream
  };

  return s => s.map(invoke).parallel(parallel);
};

exports.invokeLambda = invokeLambda;